 Rem File: Cmd083a.bas
 Rem Sub: Display.Information2
 Rem $Include: 'dndbbs.inc'
 On Error Goto Main.Error
 If Chained<>-2 Then
    Color 15,0
    Print "DNDBBS Command 083a -- Display.Information2."
    Color 7,0
    End
 Endif
 Call Display.Information2
Main.Resume:
 Chain DND.Path+"DNDBBS.EXE"
 End
Main.Error:
 Resume Main.Resume

Sub Display.Information2
 On Local Error Goto ErrorTrp33
 Gosub Get.Config3
 If TempX Then
    Gosub Display.Item
    Exit Sub
 Endif    
 VarA$=Parsed.Command1
 VarB$=Parsed.Command2
 ' check shell commands
 If Instr(Parsed.command2," ")=0 Then
    ' check shell command
    Select Case Lcase$(Parsed.Command1)
    Case "dir", "dirs", "files"
       Parsed.Command1=Nul
       Goto DosDir
    Case "tree", "stree", "directory"
       Parsed.Command1=Nul
       Goto DosTree
    Case "whereis"
       Parsed.Command1=Nul
       Goto DosWhereis
    Case "volumes", "disks"
       Parsed.Command1=Nul
       Goto DosVols
    Case "zip", "pkzip"
       Parsed.Command1=Nul
       Goto DosZip
    End Select
 Endif
 ' check shell commands
 Parsed.Command1=VarA$
 Parsed.Command2=VarB$
 If Instr(Parsed.Command2," ") Then
    ' look item user
    Call ParseX
    ' parsed.command1=user
    ' parsed.command2=item
    Call Numeric
    ' check shell command w/ parameter
    Select Case Lcase$(Parsed.Command2)
    Case "dir", "dirs", "files"
       Goto DosDir
    Case "tree", "stree", "directory"
       Goto DosTree
    Case "whereis"
       Goto DosWhereis
    Case "volumes", "disks"
       Goto DosVols
    Case "zip", "pkzip"
       Goto DosZip
    End Select
 Endif
 If Params>1 Then
    Strng="I can't examine that!"
    Call IO.O
    Exit Sub
 Endif

 Rem *** special look/iden functions:

 Select Case Lcase$(Parsed.Command1)
 Case "guestlines", "phonenumbers", "phonelines"
    Graphics.Off=False
    Strng="List of phone lines:"
    Call IO.O
    TempC=False
    TempD=False
    For VarQ=1 To 127
       Strng=Rtrim$(GuestLines(VarQ))
       If Len(Strng) Then
          Strng=Ltrim$(Str$(VarQ))+". "+Strng
          Graphics.Off=True
          Call IO.O
          TempD=True
          If Continuous=False Then
             TempC=TempC+1
             If TempC>=User.Pagelength-2 Then
                TempC=False
                Call More.Prompt
                If No Or Quit Then
                   Exit Sub
                Endif
             Endif
          Endif
       Endif
    Next
    If TempD=False Then
       Strng="No phone lines found."
       Call IO.O
    Endif
    If TempC Then
       Call More.Prompt
    Endif
    Exit Sub
 Case "specialusers", "specialnames"
    If Local.Mode Or Debug.Mode Or Sysop Then
       Graphics.Off=False
       Strng="List of special users:"
       Call IO.O
       TempC=False
       TempD=False
       For VarZ=1 To Special.Names
          Var1$=Rtrim$(SpecialUserTime(VarZ))
          VarX$=Lcase$(Rtrim$(SpecialUserName(VarZ)))
          If Len(VarX$) Then
             Mid$(VarX$,1,1)=Ucase$(Mid$(VarX$,1,1))
          Endif
          Graphics.Off=True
          VarX$=Lcase$(VarX$)
          If Len(VarX$) Then
             Mid$(VarX$,1,1)=Ucase$(Mid$(VarX$,1,1))
          Endif
          Strng=VarX$+" time restriction is "+Var1$
          Call IO.O
          TempD=True
          If Continuous=False Then
             TempC=TempC+1
             If TempC>=User.Pagelength-2 Then
                TempC=False
                Call More.Prompt
                If No Or Quit Then
                   Exit Sub
                Endif
             Endif
          Endif
       Next
       If TempD=False Then
          Strng="No special users found."
          Call IO.O
       Endif
       If TempC Then
          Call More.Prompt
       Endif
    Endif
    Exit Sub
 Case "create", "created"
    Graphics.Off=False
    Strng="Objects created."
    Call IO.O
    Graphics.Off=True
    For Var1=1 To 10
       Select Case Var1
       Case 1
          Strng="Actions"
       Case 2
          Strng="Monclass"
       Case 3
          Strng="Monster"
       Case 4
          Strng="Nonplayer"
       Case 5
          Strng="Object"
       Case 6
          Strng="Player"
       Case 7
          Strng="Room"
       Case 8
          Strng="Spell"
       Case 9
          Strng="Treasure"
       Case 10
          Strng="User"
       End Select
       Strng=Strng+":"+Str$(UserRecord.ObjectsCreated(Var1))
       Call IO.O
    Next
    Call More.Prompt
    Exit Sub
 Case "wishes"
    Strng="Wishes left: "
    Select Case UserRecord.WishsLeft
    Case -1
       Strng=Strng+"Unlimited"
    Case 0
       Strng=Strng+"None"
    Case 1 To 10
       Strng=Strng+Rtrim$(Numeral(UserRecord.WishsLeft))
    Case Else
       Strng=Strng+Form$(Cdbl(UserRecord.WishsLeft))
    End Select
    Strng=Strng+"."
    Call IO.O
    Exit Sub
 Case "classnames"
    Graphics.Off=False
    Strng="Classnames:"
    Call IO.O
    Graphics.Off=True
    Strng="Classname        High Classname"
    Call IO.O
    Strng=String$(31,"-")
    Call IO.O
    For Temp1=1 To MaxClassNames
       Strng=Lcase$(Rtrim$(Class.Name(Temp1)))
       Call Capitalize(Strng)
       Strng=Strng+Space$(16-Len(Strng))+" "
       Out2=Lcase$(Rtrim$(High.Class.Name(Temp1)))
       Call Capitalize(Out2)
       Strng=Strng+Out2
       Call IO.O
    Next
    Call More.Prompt
    Exit Sub
 Case "pagetimes"
    Strng=Rtrim$(GuestRecord.PageTimes)
    If Strng=Nul Then
       Strng="<none>"
    Endif
    Strng="Sysop page times: "+Strng
    Call IO.O
    Exit Sub
 Case "roomnumber"
    Strng="You are in room #"+Mid$(Str$(Room),2)+"."
    Call Safe.Room
    If TempA Then
       Strng=Strng+" <safe haven>"
    Endif
    Call IO.O
    Exit Sub
 Case "maxroomnumber"
    Strng="Max room:"+Str$(Lof(RoomFile)/RoomRecLen)+"."
    Call IO.O
    Exit Sub
 Case "monclass", "monsterclass", "classnumber"
    Call Safe.Room
    Strng="This room monclass:"
    If TempA Then
       Strng=Strng+" <safe haven>."
    Else
       Strng=Strng+Str$(RoomRecord.MonClass)+"."
    Endif
    Call IO.O
    Exit Sub
 Case "roomaction", "actionnumber"
    Strng="This room action:"+Str$(RoomRecord.Action)+"."
    Call IO.O
    Exit Sub
 Case "toggle"
    Room.Toggle=Not Room.Toggle
    If Room.Toggle Then
       Strng="Sorted inventory toggled on."
    Else
       Strng="Sorted inventory toggled off."
    Endif
    Call IO.O
    Exit Sub
 Case "dndbbs.doc", "dndcnfg.doc", "dndedit.doc", "sysop.doc", "edit.doc", "sic.doc", "tumbler.doc", "tumbler.dat"
    FileName=DND.Path+Lcase$(Parsed.Command1)
    Strng="[xoff]"
    Call Convert.String
    Call Out.File(FileName,"-2")
    Strng="[xon]"
    Call Convert.String
    Call IO.O
    Exit Sub
 ' ANSI.Keys
 Case "ansikeys"
    Strng="ANSI keys:"
    Call IO.O
    For Var=1 To 26
       Strng=Chr$(Var+64)+": "
       If Rtrim$(ANSI.Keys(Var))=Nul Then
          Strng=Strng+"<none>"
       Else
          Strng=Strng+Rtrim$(ANSI.Keys(Var))
       Endif
       Call IO.O
       If Var=13 Then
          Call More.Prompt
       Endif
    Next
    Call More.Prompt
    Exit Sub
 ' network
 Case "netview", "network", "servers", "workstation"
    ' verify local sysop
    OptionX=Option6
    If Sysop And Local.Mode Then
       Eat$=Nul
    Else
       If OptionQ=False Then
          Strng="Restricted command!"
          Call IO.O
          Exit Sub
       Endif
    Endif
    If OptionX=False Then
       Strng="Restricted command!"
       Call IO.O
       Exit Sub
    Endif
    ' get local computer name
    Call Get.Machine.Name(VarQ$)
    ' make filenames for shell
    Filename$="dndtmp"+NodeX+".bat"
    Filename1$="dndtmp"+NodeX+".txt"
    Filename2$="dndtmp"+NodeX+".lst"
    Close #TempFile1
    Open Filename$ For Output As #TempFile1
    Print #TempFile1,"@echo off"
    Print #TempFile1,"ipconfig | find "+Chr$(34)+"IPv4"+Chr$(34)+" > "+Filename1$
    Print #TempFile1,"net view > "+Filename2$
    Print #TempFile1,"exit"
    Close #TempFile1
    ' perform shell
    Call Close.Files
    Call Status.Line(-2)
    Call ScreenANSI(4,37,7)
    Shell Filename$
    Call Open.Shell.Files
    Call Status.Line(1)
    ' get IP address of local computer
    Var=3
    Close #TempFile1
    Open Filename1$ For Input As TempFile1
    If Eof(TempFile1)=0 Then
       Line Input #TempFile1,VarX$
       If Lcase$(Left$(VarX$,22))="program too big to fit" Then
          VarX$=Nul
       Else
          Var1=Instr(VarX$,":")
          If Var1 Then
             VarX$=Mid$(VarX$,Var1+1)
             If VarQ$=Nul Then
                Strng="This computer:"+VarX$
                Var=Var+1
                Call IO.O
             Endif
          Else
             VarX$=Nul
          Endif
       Endif
    Endif
    ' read all netpaths
    Graphics.Off=False
    Strng="The following net paths were found:"
    Call IO.O
    Strng="Server Name            Remark"
    Call IO.O
    Strng=String$(40,"-")
    Call IO.O
    Graphics.Off=True
    Close #TempFile1
    Open Filename2$ For Input As TempFile1
    VarX=0
    Do While Lost.Carrier=False
       If Eof(TempFile1) Then
          Exit Do
       Endif
       Line Input #TempFile1,Var$
       If Lcase$(Left$(Var$,22))="program too big to fit" Then
          Strng="Error reading net view. Use Shroom."
          Call IO.O
          VarX=-1
          Exit Do
       Endif
       If Left$(Var$,2) = "\\" Then
          Strng=Var$
          Call IO.O
          VarZ$=Left$(Var$,23)
          VarZ$=Mid$(VarZ$,3)
          VarZ$=Rtrim$(VarZ$)
          If VarZ$=VarQ$ Then
             If Len(VarX$) Then
                Strng="   ("+Ltrim$(VarX$)+")"
                Call IO.O
                Var=Var+1
             Endif
          Endif
          VarX=-1
          Var=Var+1
          If Var>=User.Pagelength-2 Then
             Var=False
             If Continuous=False Then
                Call More.Prompt
                If No Or Quit Then
                   Exit Do
                Endif
             Endif
          Endif
       Endif
    Loop
    If VarX=0 Then
       Strng="No nets found."
       Call IO.O
    Endif
    If Var Then
       Call More.Prompt
    Endif
    Exit Sub
 ' modem
 Case "modem"
    If Local.Mode Then
       Strng="There's no modem here.."
       Call IO.O
    Endif
    If Local.Mode=False Then
       Strng="It's a modem.."
       Call IO.O
       Graphics.Off=False
       Strng="Modem comm info:"
       Call IO.O
       Graphics.Off=True
       Strng="Comm:"+Str$(Port+1)+" (port:"+Str$(Port)+")"
       Call IO.O
       Strng="Computer to modem:"+Str$(Modem.Baud)
       Call IO.O
       If BBS.Mode=False Then
          Strng="Modem to modem: "+Modem.Return
          Call IO.O
       Endif
       Strng="Fossil: "
       If Fossil.Active Then
          Strng=Strng+"Yes"
          If Fossil.Active=1 Then
             Strng=Strng+": X00"
          Endif
       Else
          Strng=Strng+"No"
       Endif
       Call IO.O
       Call More.Prompt
    Endif
    Exit Sub
 ' options
 Case "options"
    Do While Lost.Carrier=False
       Strng="Enter (L)ist, (S)earch, (Q)uit? "
       No.Input.Out="Q"
       Call IO.I
       If Quit Then
          Exit Sub
       Endif
       If Ucase$(Out2)="L" Then
          Exit Do
       Endif
       If Ucase$(Out2)="S" Then
          Exit Do
       Endif
    Loop
    If Ucase$(Out2)="S" Then
       Strng="Enter command block string? "
       Call IO.I
       If Len(Out2) Then
          If Left$(Out2,1)="[" And Right$(Out2,1)="]" Then
             Var1$=Out2
          Else
             Var1$="["+Out2+"]"
          Endif
          Var1$=Ucase$(Var1$)
          VarX=False
          VarZ=False
          Do While Lost.Carrier=False
             VarX=VarX+1
             If VarX>Options.Lines Then
                Exit Do
             Endif
             Var$=Ucase$(Ltrim$(Rtrim$(Options.Array(VarX))))
             If Var$=Var1$ Then
                Var2=1
                Strng=Var$
                Call IO.O
                VarZ=True
                Continuous=False
                Do While Lost.Carrier=False
                   VarX=VarX+1
                   If VarX>Options.Lines Then
                      Exit Do
                   Endif
                   Var$=Ltrim$(Rtrim$(Options.Array(VarX)))
                   If Ucase$(Var$)="[END]" Then
                      Exit Do
                   Endif
                   If Len(Var$)>=80 Then
                      Var2=Var2+1
                   Endif
                   Strng=Var$
                   Call IO.O
                   Var2=Var2+1
                   If Var2>=User.Pagelength-2 Then
                      Var2=False
                      If Continuous=False Then
                         Call More.Prompt
                         If No Or Quit Then
                            Exit Do
                         Endif
                      Endif
                   Endif
                Loop
             Endif
          Loop
       Endif
       If VarZ=False Then
          Strng="Command block "+Var1$+" not found."
          Call IO.O
       Endif
       Call More.Prompt
       Exit Sub
    Endif
    Var2=1
    Var2!=0!
    For Var=1 To Options.Lines
       Var2!=Var2!+Len(Ltrim$(Rtrim$(Options.Array(Var))))
    Next
    Strng="Lines:"+Str$(Options.Lines)+" Bytes: "+Form$(Cdbl(Var2!))+"."
    Call IO.O
    Continuous=False
    For Var=1 To Options.Lines
       Var$=Ltrim$(Rtrim$(Options.Array(Var)))
       If Len(Var$)>=80 Then
          Var2=Var2+1
       Endif
       Strng=Var$
       Call IO.O
       If Ucase$(Var$)="[END]" Then
          Var2=False
          If Continuous=False Then
             Call More.Prompt
             If No Or Quit Then
                Exit For
             Endif
          Endif
       Else
          Var2=Var2+1
          If Var2>=User.Pagelength-2 Then
             Var2=False
             If Continuous=False Then
                Call More.Prompt
                If No Or Quit Then
                   Exit For
                Endif
             Endif
          Endif
       Endif
    Next
    Exit Sub
 End Select
 Strng="I can't examine that!"
 Call IO.O
 VarA$=Lcase$(VarA$)
 VarB=False
 For Var=Len(VarA$) To 1 Step -1
    VarB$=Mid$(VarA$,Var,1)
    If VarB$>="0" And VarB$<="9" Then
       VarB=Var
    Else
       Exit For
    Endif
 Next
 If VarB>1 Then
    If Mid$(VarA$,VarB-1,1)<>"#" Then
       Strng="Did you mean "+Quote$+Left$(VarA$,VarB-1)+"#"+Mid$(VarA$,VarB)+Quote$+"?"
       Call IO.O
       Exit Sub
    Endif
 Endif
 VarA$=Stored.Parsed.Command1
 If Len(VarA$)>2 Then
    If Left$(VarA$,1)=Quote$ And Right$(VarA$,1)=Quote$ Then
       Strng="Did you try it without the quotes?"
       Call IO.O
       Exit Sub
    Endif
    If Left$(VarA$,1)=Chr$(34) And Right$(VarA$,1)=Chr$(34) Then
       Strng="Did you try it without the quotes?"
       Call IO.O
       Exit Sub
    Endif
 Endif
 Exit Sub

' get dos dir
DosDir:
 OptionX=Option1
 ' make variables for shell
 Var2$="dir *.* /S" ' recurse
 If Len(Parsed.Command1) Then
    Var2$="dir "+Parsed.Command1
 Endif
 Var2$=Var2$+"/-P" ' disable prompt
 Var2$=Var2$+"/-W" ' disable wide list
 Goto ShellFilenames

' get dos tree
DosTree:
 OptionX=Option2
 ' make variables for shell
 Var2$="stree *.* /r/c"
 If Len(Parsed.Command1) Then
    Var2$="stree "+Parsed.Command1
    If Instr(Lcase$(Var2$),"/c")=0 Then
       Var2$=Var2$+"/c"
    Endif
 Endif
 Goto ShellFilenames

' get dos whereis
DosWhereis:
 OptionX=Option3
 ' make variables for shell
 Var2$="whereis *.* /r/l/c"
 If Len(Parsed.Command1) Then
    Var2$="whereis "+Parsed.Command1
    If Instr(Lcase$(Var2$),"/c")=0 Then
       Var2$=Var2$+"/c"
    Endif
 Endif
 Goto ShellFilenames

' get dos volumes
DosVols:
 OptionX=Option4
 ' make variables for shell
 Var2$="listvols /a/b/c/e/f/g"
 If Len(Parsed.Command1) Then
    Var2$="listvols "+Parsed.Command1
    If Instr(Lcase$(Var2$),"/c")=0 Then
       Var2$=Var2$+"/c"
    Endif
 Endif
 Goto ShellFilenames

' get dos pkzip
DosZip:
 OptionX=Option5
 ' make variables for shell
 If Len(Parsed.Command1) Then
    Var2$="pkzip /vt "+Parsed.Command1
 Else
    Strng="Missing filename."
    Call IO.O
    Exit Sub
 Endif

ShellFilenames:
 ' verify local sysop
 If Sysop And Local.Mode Then
    Eat$=Nul
 Else
    If OptionQ=False Then
       Strng="Restricted command!"
       Call IO.O
       Exit Sub
    Endif
 Endif
 If OptionX=False Then
    Strng="Restricted command!"
    Call IO.O
    Exit Sub
 Endif
 ' check switch
 If Instr(Var2$,"-?") Then
    Strng="Unknown command!"
    Call IO.O
    Exit Sub
 Endif
 If Instr(Var2$,"/?") Then
    Strng="Unknown command!"
    Call IO.O
    Exit Sub
 Endif
 ' make filenames for shell
 Filename1$="dndtmp"+NodeX+".txt"
 Var2$=Var2$+" > "+Filename1$
 Close #TempFile1
 Filename$="dndtmp"+NodeX+".bat"
 Open Filename$ For Output As #TempFile1
 Print #TempFile1,"@echo off"
 Print #TempFile1,Var2$
 Print #TempFile1,"exit"
 Close #TempFile1
 ' perform shell
 Call Close.Files
 Call Status.Line(-2)
 Call ScreenANSI(4,37,7)
 Shell Filename$
 Call Open.Shell.Files
 Call Status.Line(1)
 ' read shell file
 Strng="[xoff]"
 Call Convert.String
 Call Out.File(FileName1$,"-2")
 Strng="[xon]"
 Call Convert.String
 Call IO.O
 Exit Sub

Get.Config3:
 VarX=0
 Option1=-1
 Option2=-1
 Option3=-1
 Option4=-1
 Option5=-1
 Option6=-1
 OptionQ=0
 Do
    VarX=VarX+1
    If VarX>Options.Lines Then
       Exit Do
    Endif
    Var$=Ltrim$(Rtrim$(Options.Array(VarX)))
    If Ucase$(Var$)="[CMD083]" Then
       Do
          VarX=VarX+1
          If VarX>Options.Lines Then
             Return
          Endif
          Var$=Ltrim$(Rtrim$(Options.Array(VarX)))
          If Ucase$(Var$)="[END]" Then
             Return
          Endif
          Var=Instr(Var$,"=")
          If Var Then
             Var2$=Lcase$(Ltrim$(Rtrim$(Left$(Var$,Var-1))))
             Var3Z$=Lcase$(Ltrim$(Rtrim$(Mid$(Var$,Var+1))))
             Select Case Var2$
             Case "allow.remote.shell"
                Select Case Var3Z$
                Case "-1", "true", "on"
                   OptionQ=-1
                End Select
             Case Else
                If Left$(Var2$,17)="allow.sysop.shell" Then
                   VarZ2=True
                   Select Case Var3Z$
                   Case "0", "false", "off"
                      VarZ2=False
                   End Select
                   VarQ=Int(Val(Mid$(Var2$,18,1)))
                   Select Case VarQ
                   Case 1
                      Option1=VarZ2
                   Case 2
                      Option2=VarZ2
                   Case 3
                      Option3=VarZ2
                   Case 4
                      Option4=VarZ2
                   Case 5
                      Option5=VarZ2
                   Case 6
                      Option6=VarZ2
                   End Select
                Endif
             End Select
          Endif
       Loop
    Endif
 Loop
 Return

Display.Item:
 ' object
 If Temp7!<SFalse Then
    Graphics.Off=True
    Strng=Prefix1+Rtrim$(ObjectRecord.Prefix1)+Out3
    Call Convert.ANSI(True,VarQ,VarR)
    Carriage.Return=True
    Graphics.On=True
    Call IO.O
    Graphics.On=False
    Strng=Nul
    If ObjectRecord.DoorLock>1 Then
       Strng=Strng+" [locked]"
    Else
       If ObjectRecord.DoorLock=1 Then
          If ObjectRecord.Closed Then
             Strng=Strng+" [closed]"
          Endif
       Endif
    Endif
    If ObjectRecord.Invisible Then
       Strng=Strng+" [inv]"
    Else
       If MessWorkRecord6.Plus=Hidden.Object Then
          Strng=Strng+" [inv]"
       Endif
    Endif
    If Sysop And Debug.Mode Then
       Strng2=Rtrim$(ObjectRecord.PortalPassword)
       If Len(Strng2) Then
          Call Crypto(Strng2)
          Strng=Strng+" {"+Lcase$(Strng2)+"}"
       Endif
    Endif
    Strng=Strng+"."
    Call IO.O
    If Last.Command.Number=Identify.Command Then
       If ObjectRecord.KeyNumber Then
	  Strng="It requires key number "+_
          Right$(Str$(ObjectRecord.KeyNumber+1000000!),6)+"."
	  Call IO.O
       Endif
    Endif
    Strng=ObjectRecord.LongDesc
    Strng=Rtrim$(Strng)
    If Strng<>Nul Then
       Call Convert.ANSI(True,VarQ,VarR)
       Graphics.On=True
       Call IO.O
       Graphics.On=False
    Endif
    Graphics.Off=False
    ' check for multiline description
    VarS2=False
    For VarS1=1 To 19
       If ObjectRecord.ObjDesc(VarS1)>0! Then
          VarS2=True
          Exit For
       Endif
    Next
    ' display multiline description
    If VarS2 Then
       FileName=DND.Path+"objdesc.dat"
       Close #TempFile1
       Open FileName For Random Shared As #TempFile1 Len=80
       For TempY=1 To 19
          TempQ!=ObjectRecord.ObjDesc(TempY)
          If TempQ!>SFalse And TempQ!<=Lof(TempFile1)/80! Then
             Call Read.Record(ObjDescFile,TempQ!)
             Strng=BufferRecord.Buffer
             Strng=Rtrim$(Strng)
             Call Convert.String
             Call Convert.ANSI(True,VarQ,VarR)
             Graphics.On=True
             Call IO.O
             Graphics.On=False
          Endif
       Next
       Close #TempFile1
       Call More.Prompt
    Endif
    Graphics.Off=False
    Return
 Endif
 ' treasure
 If Temp7!>SFalse Then
    Graphics.Off=True
    If TreasureRecord.Scroll Then
       Graphics.Off=True
       Var$=Lcase$(Rtrim$(TreasureRecord.TreasureName))
       Var2$=Rtrim$(TreasureRecord.Prefix1)
       Strng="It's "+Var2$+Var$
       Call Convert.ANSI(True,VarQ,VarR)
       Carriage.Return=-1
       Graphics.On=True
       Call IO.O
       Graphics.On=False
       Graphics.Off=True
       Strng="!"
       Call IO.O
       Graphics.Off=False
       ' check if scroll was written on.
       Gosub Display.Scroll
       ' check scroll has spell.
       If TreasureRecord.Spell Then
          Temp2!=TreasureRecord.Spell
          If Temp2!>SFalse And Temp2!<=Lof(SpellFile)/SpellRecLen Then
             Graphics.Off=True
             Call Read.Record(SpellFile,Temp2!)
             Out2=SpellRecord.SpellName
             Out2=Rtrim$(Out2)
             Out2=Lcase$(Out2)
             Strng="It's spell is: "+Quote$++Out2+Quote$
             Call Convert.ANSI(True,VarQ,VarR)
             Graphics.On=True
             Call IO.O
             Graphics.On=False
	     Out2=SpellRecord.Chant
	     Out2=Rtrim$(Out2)
	     Out2=Lcase$(Out2)
             Strng="It reads: "+Quote$++Out2+Quote$
	     Call IO.O
             VarQ=True
          Endif
       Endif
       ' remove written messages.
       Close #LogFile
       FileName=DND.Path+"writing.log"
       Open FileName For Random Shared As #LogFile Len=LogRecLen
       For Var=1 To 4
          Temp1!=MessWorkRecord6.Desc(Var)
          If Temp1!>0! And Temp1!<=Lof(LogFile)/LogRecLen Then
             LogRecord.User=0!
             LogRecord.Message=Nul
             LogRecord.Clock=Nul
             Call Write.Record(LogFile,Temp1!)
          Endif
       Next
       ' always remove scrolls.
       Graphics.Off=False
       Strng="It disintegrated!"
       Call IO.O
       ' remove inventory.
       Select Case Temp4
       Case True ' in room inventory.
          Call Delete.List.Node(Temp5!)
          Call Clear.List.Node
          Call Write.Record(RoomInvFile,Temp5!)
       Case False ' in user inventory.
          For Var=1 To 4
             MessWorkRecord6.Desc(Var)=0!
          Next
          Call Write.Record(MessWorkFile6,Temp5!)
          Call Discard(Temp5!,True)
       End Select
       Return
    Endif
    Strng=Prefix1+Rtrim$(TreasureRecord.Prefix1)+Out3
    Call Convert.ANSI(True,VarQ,VarR)
    Carriage.Return=True
    Graphics.On=True
    Call IO.O
    Graphics.On=False
    Strng=Nul
    If TreasureRecord.MasterKey Then
       Strng=Strng+" (#master)"
    Else
       If TreasureRecord.KeyNumber Then
          Strng=Strng+" (#"+Right$(Str$(TreasureRecord.KeyNumber+1000000!),6)+")"
       Endif
    Endif
    Temp1=TreasureRecord.Plus
    If Temp1 Then
       Call Treasure.Plus
       If Out2<>Nul Then
          Strng=Strng+" "+Out2
       Endif
    Endif
    If TreasureRecord.Vehicle Then
       If Temp1>False Then
          Strng=Strng+" (+"+Mid$(Str$(Temp1),2)+")"
       Endif
    Endif
    If TreasureRecord.Spell Then
       Call Read.Record(SpellFile,TreasureRecord.Spell)
       Strng=Strng+" (+"+Mid$(Str$(SpellRecord.Level),2)+")"
    Endif
    If TreasureRecord.LightType Then
       If Temp6>False Then
          Strng=Strng+" [unlit]"
       Endif
       If Temp6<False Then
          Strng=Strng+" [lit]"
       Endif
    Endif
    If TreasureRecord.Invisible Then
       Strng=Strng+" [inv]"
    Else
       If Temp4=True Then ' in room inventory.
          If MessWorkRecord6.Plus=Hidden.Object Then
             Strng=Strng+" [inv]"
          Endif
       Endif
    Endif
    Strng=Strng+"."
    Call IO.O
    If Temp6<False Then
       If TreasureRecord.LightType=False Then
          VarQ=Abs(Temp6)
          Select Case VarQ
          Case 1
             Strng="It has one charge."
          Case 2 To 10
             Strng="It has "+Rtrim$(Numeral(VarQ))+" charges."
          Case Else
             Strng="It has "+Form$(Cdbl(VarQ))+" charges."
          End Select
          Call IO.O
       Endif
    Endif
    If TreasureRecord.Vehicle Then
       Var2!=MessWorkRecord6.User
       If Var2!>SFalse And Var2!<=Lof(UserFile)/UserRecLen Then
          Call Read.Record(UserFile2,Var2!)
          Carriage.Return=True
          Strng="It's being used by "
          Call IO.O
          Strng=UserRecord2.CodeName
          Strng=Rtrim$(Strng)
          Strng=Lcase$(Strng)
          Strng=Left$(Strng,30)
          Mid$(Strng,1,1)=UCase$(Mid$(Strng,1,1))
          Strng=Rtrim$(UserRecord2.Prefix1)+Strng
          Call Convert.ANSI(True,VarQ,VarR)
          Carriage.Return=True
          Graphics.On=True
          Call IO.O
          Graphics.On=False
          Strng="."
          Call IO.O
          If TreasureRecord.Occupants>False Then
             Carriage.Return=True
             Strng="Passengers: "
             Call IO.O
             Var=False
             For Var2=1 To 4
                Var2!=MessWorkRecord6.Temp(Var2)
                If Var2!>SFalse And Var2!<=Lof(UserFile)/UserRecLen Then
                   Call Read.Record(UserFile2,Var2!)
                   Carriage.Return=True
                   Strng=UserRecord2.CodeName
                   Strng=Rtrim$(Strng)
                   Strng=Lcase$(Strng)
                   Mid$(Strng,1,1)=UCase$(Mid$(Strng,1,1))
                   Call IO.O
                   If Var Then
                      Strng=", "+Strng
                   Endif
                   Var=True
                Endif
             Next
             If Var Then
                Strng="."
             Else
                Strng="<none>"
             Endif
             Call IO.O
          Endif
       Endif
    Endif
    Strng="Treasure type: "
    VarQ=TreasureRecord.WeaponNumber
    If VarQ>=1 And VarQ<=10 Then
       Strng=Strng+Rtrim$(InventoryNames(VarQ))
       Select Case VarQ
       Case 2, 6
          Strng=Strng+"s"
       Case 4
          Strng=Strng+" (left hand)"
       Case 9
          Strng=Strng+" (right hand)"
       Case 7
          If TreasureRecord.TwoHanded Then
             Strng=Strng+" (two-handed)"
          Endif
       End Select
       Call IO.O
       If Rtrim$(TreasureRecord.ProperName)<>"" Then
          Strng="It's proper name is: "
          Var$=Lcase$(Rtrim$(TreasureRecord.ProperName))
          Mid$(Var$,1,1)=Ucase$(Mid$(Var$,1,1))
          Strng=Strng+Var$
          Call IO.O
       Endif
    Endif
    If TreasureRecord.Proficiency Then
       Strng=Weapon.Type.Name(TreasureRecord.Proficiency)
       Strng=Rtrim$(Strng)
       Strng="This is a "+Strng+" weapon."
       Call IO.O
    Endif
    VarQ=TreasureRecord.TimesCursed
    Select Case VarQ
    Case 1
       Strng="It's been cursed once.."
       Call IO.O
    Case Is>1
       Strng="It's been cursed "+Form$(Cdbl(VarQ))+" times.."
       Call IO.O
    End Select
    VarQ=TreasureRecord.TimesBlessed
    Select Case VarQ
    Case 1
       Strng="It's been blessed once.."
       Call IO.O
    Case Is>1
       Strng="It's been blessed "+Form$(Cdbl(VarQ))+" times.."
       Call IO.O
    End Select
    If Last.Command.Number=Identify.Command Then
       Var#=TreasureRecord.Gold
       Select Case Var#
       Case 0#
          Strng="It's worth zero gold pieces."
       Case 1#
          Strng="It's worth one gold piece."
       Case 2# To 10#
          Strng="It's worth "+Rtrim$(Numeral(Cint(Var#)))+" gold pieces."
       Case Else
          Call Amount(Var#,VarQ2$)
          Strng="It's worth"+VarQ2$+" gold pieces."
       End Select
       Call IO.O
       Var=TreasureRecord.Weight
       Select Case Var
       Case 0
          Strng="It weighs zero gold pieces."
       Case 1
          Strng="It weighs one gold piece."
       Case 2 To 10
          Strng="It weighs "+Rtrim$(Numeral(Var))+" gold pieces."
       Case Else
          Strng="It weighs "+Form$(Cdbl(Var))+" gold pieces."
       End Select
       Call IO.O
       VarX=TreasureRecord.RingType
       If VarX>=1 And VarX<=9 Then
          Strng=Nul
          Select Case VarX
          Case 1
             Strng="protection from poison"
          Case 2
             Strng="protection from level drain"
          Case 3
             Var1!=TreasureRecord.RingSpell
             If Var1!=STrue Then
                Strng="protection from any spell"
             Else
                If Var1!>SFalse And Var1!<=Lof(SpellFile)/SpellRecLen Then
                   Call Read.Record(SpellFile,Var1!)
                   If SpellRecord.SpellType=Invisibly Then
                      Strng="invisibility"
                   Else
                      Strng=Rtrim$(SpellRecord.Prefix1)
                      Strng="protection from "+Strng+Rtrim$(Lcase$(SpellRecord.SpellName))+" spell"
                   Endif
                Endif
             Endif
          Case 4
             Strng="protection from traps"
          Case 5
             Strng="protection from rust"
          Case 6
             Strng="protection from theft"
          Case 7
             Strng="protection from damage"
          Case 8
             Strng="protection from fumble"
          Case 9
             Strng="protection from teleporting"
          End Select
          If Len(Strng) Then
             Strng="It's ring spell is "+Strng
             Call Convert.ANSI(True,VarQ,VarR)
             Carriage.Return=True
             Graphics.On=True
             Call IO.O
             Graphics.On=False
             Strng="."
             Graphics.Off=True
             Call IO.O
          Endif
          If TreasureRecord.BindType Then
             Strng="It binds with a spell."
             Call IO.O
          Endif
       Endif
       If TreasureRecord.Spell Then
          Call Read.Record(SpellFile,TreasureRecord.Spell)
          Strng=Rtrim$(SpellRecord.Prefix1)
          Strng="It's magical spell is "+Strng+Rtrim$(SpellRecord.SpellName)+"."
          Call Convert.ANSI(True,VarQ,VarR)
          Graphics.On=True
          Call IO.O
          Graphics.On=False
          Graphics.Off=True
          If SpellRecord.SpellType=Teleporting Then
             If SpellRecord.Teleport<SFalse Then
                Strng="It prompts for room number."
                Call IO.O
             Endif
             If SpellRecord.Teleport>SFalse Then
                Strng="It teleports to room"+Str$(SpellRecord.Teleport)+"."
                Call IO.O
             Endif
          Endif
       Endif
       If TreasureRecord.Ammunition Or TreasureRecord.LaunchAmmo Then
	  Strng="It's ammunition."
	  Call IO.O
       Else
          If TreasureRecord.Potion Then
             If TreasureRecord.Liquid Then
                Strng="It's liquid."
             Else
                Strng="It's a potion."
             Endif
             Call IO.O
             Select Case Temp6
             Case IS<=False
                Strng="It has no charges."
             Case 1
                Strng="It has one charge."
             Case 2 To 10
                Strng="It has "+Rtrim$(Numeral(Temp6))+" charges."
             Case Else
                Strng="It has "+Form$(Cdbl(Temp6))+" charges."
             End Select
             Call IO.O
          Else
             If TreasureRecord.Edible Then
                If (TreasureRecord.Edible And 1)=1 Then
                   Strng="It's edible."
                   Call IO.O
                Endif
                If (TreasureRecord.Edible And 2)=2 Then
                   Strng="It's slippery."
                   Call IO.O
                Endif
                If (TreasureRecord.Edible And 4)=4 Then
                   Strng="It's smokable."
                   Call IO.O
                Endif
                If (TreasureRecord.Edible And 8)=8 Then
                   Strng="It's burnable."
                   Call IO.O
                Endif
                Select Case Abs(Temp6)
                Case 0
                   Strng="It has no charges."
                Case 1
                   Strng="It has one charge."
                Case 2 To 10
                   Strng="It has "+Rtrim$(Numeral(Abs(Temp6)))+" charges."
                Case Else
                   Strng="It has "+Form$(Cdbl(Abs(Temp6)))+" charges."
                End Select
                Call IO.O
             Else
                If TreasureRecord.Vehicle Then
                   Strng="It's a vehicle."
                   Call IO.O
                   Select Case Temp6
                   Case -1
                      Strng="It cannot be hit."
                   Case 0
                      Strng="It has no charges."
                   Case 1
                      Strng="It has one charge."
                   Case 2 To 10
                      Strng="It has "+Rtrim$(Numeral(Temp6))+" charges."
                   Case Else
                      Strng="It has "+Form$(Cdbl(Temp6))+" charges."
                   End Select
                   Call IO.O
                Else
                   If TreasureRecord.LightType Then
                      If Temp6<=False Then
                         Select Case Abs(Temp6)
                         Case 0
                            Strng="It's not fueled."
                         Case 1
                            Strng="It's fueled with one charge."
                         Case 2 To 10
                            Strng="It's fueled with "+Rtrim$(Numeral(Abs(Temp6)))+" charges."
                         Case Else
                            Strng="It's fueled with "+Form$(Cdbl(Abs(Temp6)))+" charges."
                         End Select
                         Call IO.O
                      Endif
                   Else
                      If TreasureRecord.Loadable Or TreasureRecord.Launchable Then
                         Select Case Temp6
                         Case IS<=0
                            Strng="It's not loaded."
                         Case 1
                            Strng="It's loaded with one charge."
                         Case 2 To 10
                            Strng="It's loaded with "+Rtrim$(Numeral(Temp6))+" charges."
                         Case Else
                            Strng="It's loaded with "+Form$(Cdbl(Temp6))+" charges."
                         End Select
                         Call IO.O
                      Else
                         If TreasureRecord.RingType Or TreasureRecord.Spell Or TreasureRecord.Plus Then
                            Select Case Temp6
                            Case IS<=0
                               Strng="It has no charges."
                            Case 1
                               Strng="It has one charge."
                            Case 2 To 10
                               Strng="It has "+Rtrim$(Numeral(Temp6))+" charges."
                            Case Else
                               Strng="It has "+Form$(Cdbl(Temp6))+" charges."
                            End Select
                            Call IO.O
                         Endif
                      Endif
                   Endif
                Endif
             Endif
          Endif
       Endif
       If TreasureRecord.Persistent Then
          Strng="It's persistent("+Mid$(Str$(TreasureRecord.PersistTime),2)+" sec.)"
          Call IO.O
          Strng="Persistent charges:"+Str$(TreasureRecord.MaxPersistCharges)
          Call IO.O
          If TreasureRecord.DischargePersist>0 Then
             Strng="Persist discharges:"+Str$(TreasureRecord.DischargePersist)+" sec."
             Call IO.O
          Endif
       Endif
    Endif
    Graphics.Off=False
 Endif
 Return

' check if item was written on.
Display.Scroll:
 VarQ=False
 Close #LogFile
 FileName=DND.Path+"writing.log"
 Open FileName For Random Shared As #LogFile Len=LogRecLen
 For Var=1 To 4
    Temp1!=MessWorkRecord6.Desc(Var)
    If Temp1!>0! And Temp1!<=Lof(LogFile)/LogRecLen Then
       Call Read.Record(LogFile,Temp1!)
       Var$=Rtrim$(LogRecord.Message)
       If Len(Var$) Then
          Strng="It was written on at "
          Var2!=LogRecord.User
          If Var2!>0! And Var2!<=Lof(UserFile2)/UserRecLen Then
             Call Read.Record(UserFile2,Var2!)
             Strng2=UserRecord2.CodeName
             Call Valid.Name(Strng2)
             If TempA Then
                Strng=Lcase$(Rtrim$(Strng2))+" wrote on it at "
                Mid$(Strng,1,1)=Ucase$(Mid$(Strng,1,1))
             Endif
          Endif
          Strng=Strng+Logrecord.Clock+".."
          Graphics.Off=True
          Call IO.O
          Strng=Var$
          Call Convert.String
          Call Convert.ANSI(True,VarQ,VarR)
          Graphics.Off=False
          Graphics.On=True
          Call IO.O
          Graphics.On=False
          VarQ=True
       Endif
    Endif
 Next
 Return
ErrorRsm33:
 Exit Sub
ErrorTrp33:
 Resume ErrorRsm33
End Sub

' store default server name
Sub Get.Machine.Name(VarX$)
 On Local Error Goto ErrorTrap19z
 DIM Default.Net AS STRING * 16
 VarX$ = Nul
 Default.Net = Nul
 InregsX.AX = &H5E00
 InregsX.DS = VARSEG(Default.Net)
 InregsX.DX = VARPTR(Default.Net)
 CALL InterruptX(&H21, InregsX, OutregsX)
 ' check error flag.
 IF (OutregsX.Flags AND &H1) = &H0 THEN
    ' read CH
    VarS = (OutregsX.CX AND &HFF00) / 256
    IF VarS > 0 THEN ' valid name.
       VarX$ = Default.Net
       Imbedded = INSTR(VarX$, CHR$(0))
       IF Imbedded THEN
          VarX$ = LEFT$(VarX$, Imbedded - 1)
       END IF
       VarX$ = UCASE$(RTRIM$(VarX$))
       EXIT SUB
    END IF
 END IF
 ' check net path.
 If VarX$ = Nul Then
    Var$ = Environ$("COMPUTERNAME")
    If Len(Var$) Then
       VarX$ = Var$
    Endif
 Endif
ErrorResume19z:
 Exit Sub
ErrorTrap19z:
 Resume ErrorResume19z
End Sub
